#include<iostream>
#include<stdlib.h>
using namespace std;
void unosN(int a[], int n)
{
    for(int i=0; i<n; i++)
        cin>>a[i];
}
void ispisN(int a[], int n)
{
    for(int i=0; i<n; i++)
        cout<<a[i]<<' ';
}
int main()
{
    int n, i, tmax1, tmax2;
    cin>>n;
    int a[n], p[n];
    unosN(a, n);
    for(i=n-1; i>=0; i--)
    {
        if(a[i]>=a[p[i+1]]){
            p[i]=i;
        }
        else
            p[i]=i+1;
    }
    for(i=0; i<n; i++)
        if(p[i]==p[i+1]){
            swap(a[p[i+1]], a[i]);
            break;
        }
    if(i==n)
        swap(a[n-1], a[n-2]);
    ispisN(a, n);

    return 0;
}